////////////////////////////////mod4/////////////////////////
#ifndef __WINLIST_H__
#define __WINLIST_H__

#include "win.h"
#include "basetools.h"

class THIWinList:public THIWin
{
   private:
   
   protected:
    TList *FList;

   public:
    string _prop_FileName;
    int line;
    BYTE _prop_AddType;
    THI_Event *_data_FileName;
    THI_Event *_data_Str;
    THI_Event *_event_onChange;

    HI_WORK_LOC(THIWinList,_work_doAdd);
    HI_WORK_LOC(THIWinList,_work_doClear);
    HI_WORK_LOC(THIWinList,_work_doDelete);
    HI_WORK_LOC(THIWinList,_work_doText);
    HI_WORK_LOC(THIWinList,_work_doLoad);
    HI_WORK_LOC(THIWinList,_work_doSave);
    HI_WORK_LOC(THIWinList,_work_doVScroll);
    HI_WORK_LOC(THIWinList,_work_doScrollV);
    HI_WORK_LOC(THIWinList,_work_doInsert);   
    HI_WORK_LOC(THIWinList,_work_doReplace);

    HI_WORK(_var_Text){ CreateData(_Data,_hie(THIWinList)->FList->Text); }
    HI_WORK(_var_Count){ CreateData(_Data,_hie(THIWinList)->FList->Count()); }
    HI_WORK_LOC(THIWinList,_var_LongStr)
    {      
           int len=0;
           int i=0;
           int cnt=FList->Count();
           while(i<cnt)
           {
              int t=SendMessage(Control->Handle,LB_GETTEXTLEN,i,0);
               if(t>len)
                 len=t;
              i++; 
           }
          CreateData(_Data,len); 
           if(len>9)// -    
             {   
          ((TListBox *)Control)->Style = WS_HSCROLL;  
         SendMessage(Control->Handle,LB_SETHORIZONTALEXTENT,len*10,0);
             }  
    } 

};

//########################################################################

void THIWinList::_work_doAdd(TData &_Data,WORD Index)
{
   string s = ReadString(_Data,_data_Str,string(_his("")));
   if( _prop_AddType == 0 )
   {
       FList->Add(s);
   }
   else
   {
       FList->Insert(0,s);
   }
   _hi_onEvent(_event_onChange);
     SendMessage(Control->Handle,EM_LINESCROLL,0,-(FList->Count()));
             TData qt;
       _var_LongStr(qt,0);
}

void THIWinList::_work_doClear(TData &_Data,WORD Index)
{
   FList->Clear();
   _hi_onEvent(_event_onChange);
}

void THIWinList::_work_doDelete(TData &_Data,WORD Index)
{
  int Ind = ToIntIndex(_Data);
  if( (Ind >= 0)&&(Ind < FList->Count()) )
  {
    FList->Delete(Ind);
    _hi_onEvent(_event_onChange);
                 TData qt;
       _var_LongStr(qt,0);
  }
}

void THIWinList::_work_doText(TData &_Data,WORD Index)
{
   FList->Clear();
   FList->Text = ToString(_Data);
   _hi_onEvent(_event_onChange);
    SendMessage(Control->Handle,EM_LINESCROLL,0,-(FList->Count()));
                TData qt;
       _var_LongStr(qt,0);
}

void THIWinList::_work_doLoad(TData &_Data,WORD Index)
{
   string fn;
   fn = ReadFileName(ReadString(_Data,_data_FileName,_prop_FileName));
   if( FileExists(fn) )
   {
     FList->Clear();
     FList->LoadFromFile(fn);
     _hi_onEvent(_event_onChange);
      SendMessage(Control->Handle,EM_LINESCROLL,0,-(FList->Count()));
                  TData qt;
       _var_LongStr(qt,0); 
   }
   else 
     MessageBox(NULL,L"  ",L"Error",MB_OK);
}

void THIWinList::_work_doSave(TData &_Data,WORD Index)
{
   FList->SaveToFile(ReadString(_Data,_data_FileName,_prop_FileName));
}

void THIWinList::_work_doVScroll(TData &_Data,WORD Index)
{
    int Ind = ToIntIndex(_Data);
  SendMessage(Control->Handle,LB_SETTOPINDEX,Ind,0);
}

void THIWinList::_work_doScrollV(TData &_Data,WORD Index)
{
    int Ind = ToIntIndex(_Data); 
    int scrl=Ind-line; 
   SendMessage(Control->Handle,EM_LINESCROLL,0,scrl);
   if(Ind==0)
   line=1;
   else line=Ind; 
}

void THIWinList::_work_doInsert(TData &_Data,WORD Index)
{  
   string s = ReadString(_Data,_data_Str,string(_his("")));
   int ind = ToIntIndex(_Data);
   _Data.data_type = data_null;
   if( (ind >= 0)&&(ind < FList->Count()) )
   {  
       FList->Insert(ind,s);
     _hi_onEvent(_event_onChange);
                  TData qt;
       _var_LongStr(qt,0);
   }
}

void THIWinList::_work_doReplace(TData &_Data,WORD Index)
{  
   string s = ReadString(_Data,_data_Str,string(_his("")));
   int ind = ToIntIndex(_Data);
   _Data.data_type = data_null;
   if( (ind >= 0)&&(ind < FList->Count()) )
   {   
       FList->Delete(ind);
       FList->Insert(ind,s);
     _hi_onEvent(_event_onChange);
                  TData qt;
       _var_LongStr(qt,0);
   }
}

#endif
